using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using MiniNWModel.Entities;

namespace MiniNWModel.Mapping
{
	public class ProductMap : EntityTypeConfiguration<Product>
	{
		public ProductMap()
		{
			// Primary Key
			this.HasKey(t => t.pid);

			// Properties
			this.Property(t => t.pid)
				.HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);
				
			// Table & Column Mappings
			this.ToTable("Products");
			this.Property(t => t.pid).HasColumnName("pid");
			this.Property(t => t.name).HasColumnName("name");
			this.Property(t => t.discontinued_date).HasColumnName("discontinued_date");
			this.Property(t => t.cid).HasColumnName("cid");

			// Relationships
			this.HasRequired(t => t.Category)
				.WithMany(t => t.Products)
				.HasForeignKey(d => d.cid);
				
		}
	}
}

