using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using MiniNWModel.Entities;
using MiniNWModel.Mapping;
using System.Data.Common;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Collections.Generic;

namespace MiniNWModel
{
    public class MiniNWContext : DbContext
    {
        static string conn = "Data Source=.;Initial Catalog=MiniNW;Persist Security Info=True;User ID=sa;Password=sasa;Pooling=False;";

        public MiniNWContext()
            : base(conn)
        {
            Database.SetInitializer<MiniNWContext>(null);
        }

        public DbSet<Category> Categories { get; set; }
        public DbSet<Product> Products { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Conventions.Remove<IncludeMetadataConvention>();
            modelBuilder.Configurations.Add(new CategoryMap());
            modelBuilder.Configurations.Add(new ProductMap());
        }

        public IEnumerable<Category> GetCategoryWithProductsWithID(int id)
        {
            var parameter = new SqlParameter
            {
                DbType = DbType.Int32,
                ParameterName = "cid",
                Value = id
            };
            //ӳټ
            var result = (from p in this.Categories.SqlQuery("EXECUTE GetCategory @cid", parameter) select p).ToList();
            return result;
        }

        public IEnumerable<Category> GetCategoryWithID(int id)
        {
            var parameter = new SqlParameter
            {
                DbType = DbType.Int32,
                ParameterName = "cid",
                Value = id
            };
            //
            var result = (from p in this.Categories.SqlQuery("EXECUTE GetCategory @cid", parameter)
                          select new
                          {
                              cid = p.cid,
                              name = p.name
                          }).ToList()
                         .Select(r => new Category()
                         {
                             cid = r.cid,
                             name = r.name
                         });
            return result;
        }

        public IEnumerable<Product> GetProductAndCategoryWithID(int id)
        {
            var parameter = new SqlParameter
            {
                DbType = DbType.Int32,
                ParameterName = "pid",
                Value = id
            };
            //ӳټ
            var result = (from p in this.Products.SqlQuery("EXECUTE dbo.GetProductAndCategory @pid", parameter) select p).ToList();
            return result;
        }

    }
}

